3 # Copyright (c) 2006 Eric Wong
9 git instaweb [options] (--start | --stop | --restart)
11 l,local only bind on 127.0.0.1
12 p,port= the port to bind to
13 d,httpd= the command to launch
14 b,browser= the browser to launch
15 m,module-path= the module path (only needed for apache2)
17 stop stop the web server
18 start start the web server
19 restart restart the web server
25 local="$(git config --bool --get instaweb.local)"
26 httpd
="$(git config --get instaweb.httpd)"
27 port
=$
(git config
--get instaweb.port
)
28 module_path
="$(git config --get instaweb.modulepath)"
30 conf
="$GIT_DIR/gitweb/httpd.conf"
34 # if installed, it doesn't need further configuration (module_path)
35 test -z "$httpd" && httpd
='lighttpd -f'
37 # any untaken local port will do...
38 test -z "$port" && port
=1234
40 resolve_full_httpd
() {
43 # ensure that the apache2/lighttpd command ends with "-f"
44 if ! echo "$httpd" |
grep -- '-f *$' >/dev
/null
2>&1
51 httpd_only
="$(echo $httpd | cut -f1 -d' ')"
52 if case "$httpd_only" in /*) : ;; *) which $httpd_only >/dev
/null
2>&1;; esac
56 # many httpds are installed in /usr/sbin or /usr/local/sbin
57 # these days and those are not in most users $PATHs
58 # in addition, we may have generated a server script
59 # in $fqgitdir/gitweb.
60 for i
in /usr
/local
/sbin
/usr
/sbin
"$fqgitdir/gitweb"
62 if test -x "$i/$httpd_only"
69 echo >&2 "$httpd_only not found. Install $httpd_only or use" \
70 "--httpd to specify another httpd daemon."
76 # here $httpd should have a meaningful value
79 # don't quote $full_httpd, there can be arguments to it (-f)
80 $full_httpd "$fqgitdir/gitweb/httpd.conf"
82 echo "Could not execute http daemon $httpd."
88 test -f "$fqgitdir/pid" && kill $
(cat "$fqgitdir/pid")
135 mkdir
-p "$GIT_DIR/gitweb/tmp"
136 GIT_EXEC_PATH
="$(git --exec-path)"
138 export GIT_EXEC_PATH GIT_DIR
142 # generate a standalone server script in $fqgitdir/gitweb.
143 cat >"$fqgitdir/gitweb/$httpd.rb" <<EOF
146 options = YAML::load_file(ARGV[0])
147 options[:StartCallback] = proc do
148 File.open(options[:PidFile],"w") do |f|
152 options[:ServerType] = WEBrick::Daemon
153 server = WEBrick::HTTPServer.new(options)
154 ['INT', 'TERM'].each do |signal|
155 trap(signal) {server.shutdown}
159 # generate a shell script to invoke the above ruby script,
160 # which assumes _ruby_ is in the user's $PATH. that's _one_
161 # portable way to run ruby, which could be installed anywhere,
163 cat >"$fqgitdir/gitweb/$httpd" <<EOF
165 exec ruby "$fqgitdir/gitweb/$httpd.rb" \$*
167 chmod +x
"$fqgitdir/gitweb/$httpd"
171 :DocumentRoot: "$fqgitdir/gitweb"
172 :DirectoryIndex: ["gitweb.cgi"]
173 :PidFile: "$fqgitdir/pid"
175 test "$local" = true
&& echo ':BindAddress: "127.0.0.1"' >> "$conf"
180 server.document-root = "$fqgitdir/gitweb"
182 server.modules = ( "mod_setenv", "mod_cgi" )
183 server.indexfiles = ( "gitweb.cgi" )
184 server.pid-file = "$fqgitdir/pid"
185 server.errorlog = "$fqgitdir/gitweb/error.log"
187 # to enable, add "mod_access", "mod_accesslog" to server.modules
188 # variable above and uncomment this
189 #accesslog.filename = "$fqgitdir/gitweb/access.log"
191 setenv.add-environment = ( "PATH" => "/usr/local/bin:/usr/bin:/bin" )
193 cgi.assign = ( ".cgi" => "" )
197 ".pdf" => "application/pdf",
198 ".sig" => "application/pgp-signature",
199 ".spl" => "application/futuresplash",
200 ".class" => "application/octet-stream",
201 ".ps" => "application/postscript",
202 ".torrent" => "application/x-bittorrent",
203 ".dvi" => "application/x-dvi",
204 ".gz" => "application/x-gzip",
205 ".pac" => "application/x-ns-proxy-autoconfig",
206 ".swf" => "application/x-shockwave-flash",
207 ".tar.gz" => "application/x-tgz",
208 ".tgz" => "application/x-tgz",
209 ".tar" => "application/x-tar",
210 ".zip" => "application/zip",
211 ".mp3" => "audio/mpeg",
212 ".m3u" => "audio/x-mpegurl",
213 ".wma" => "audio/x-ms-wma",
214 ".wax" => "audio/x-ms-wax",
215 ".ogg" => "application/ogg",
216 ".wav" => "audio/x-wav",
217 ".gif" => "image/gif",
218 ".jpg" => "image/jpeg",
219 ".jpeg" => "image/jpeg",
220 ".png" => "image/png",
221 ".xbm" => "image/x-xbitmap",
222 ".xpm" => "image/x-xpixmap",
223 ".xwd" => "image/x-xwindowdump",
224 ".css" => "text/css",
225 ".html" => "text/html",
226 ".htm" => "text/html",
227 ".js" => "text/javascript",
228 ".asc" => "text/plain",
229 ".c" => "text/plain",
230 ".cpp" => "text/plain",
231 ".log" => "text/plain",
232 ".conf" => "text/plain",
233 ".text" => "text/plain",
234 ".txt" => "text/plain",
235 ".dtd" => "text/xml",
236 ".xml" => "text/xml",
237 ".mpeg" => "video/mpeg",
238 ".mpg" => "video/mpeg",
239 ".mov" => "video/quicktime",
240 ".qt" => "video/quicktime",
241 ".avi" => "video/x-msvideo",
242 ".asf" => "video/x-ms-asf",
243 ".asx" => "video/x-ms-asf",
244 ".wmv" => "video/x-ms-wmv",
245 ".bz2" => "application/x-bzip",
246 ".tbz" => "application/x-bzip-compressed-tar",
247 ".tar.bz2" => "application/x-bzip-compressed-tar",
251 test x
"$local" = xtrue
&& echo 'server.bind = "127.0.0.1"' >> "$conf"
255 test -z "$module_path" && module_path
=/usr
/lib
/apache
2/modules
256 mkdir
-p "$GIT_DIR/gitweb/logs"
258 test x
"$local" = xtrue
&& bind='127.0.0.1:'
259 echo 'text/css css' > $fqgitdir/mime.types
261 ServerName "git-instaweb"
262 ServerRoot "$fqgitdir/gitweb"
263 DocumentRoot "$fqgitdir/gitweb"
264 PidFile "$fqgitdir/pid"
268 for mod
in mime dir
; do
269 if test -e $module_path/mod_
${mod}.so
; then
270 echo "LoadModule ${mod}_module " \
271 "$module_path/mod_${mod}.so" >> "$conf"
275 TypesConfig $fqgitdir/mime.types
276 DirectoryIndex gitweb.cgi
279 # check to see if Dennis Stosberg's mod_perl compatibility patch
280 # (<20060621130708.Gcbc6e5c@leonov.stosberg.net>) has been applied
281 if test -f "$module_path/mod_perl.so" && grep '^our $gitbin' \
282 "$GIT_DIR/gitweb/gitweb.cgi" >/dev
/null
284 # favor mod_perl if available
286 LoadModule perl_module $module_path/mod_perl.so
288 PerlPassEnv GIT_EXEC_DIR
289 <Location /gitweb.cgi>
290 SetHandler perl-script
291 PerlResponseHandler ModPerl::Registry
292 PerlOptions +ParseHeaders
299 list_mods
=$
(echo "$full_httpd" |
sed "s/-f$/-l/")
300 $list_mods |
grep 'mod_cgi\.c' >/dev
/null
2>&1 || \
301 echo "LoadModule cgi_module $module_path/mod_cgi.so" >> "$conf"
303 AddHandler cgi-script .cgi
304 <Location /gitweb.cgi>
312 s#^(my|our) \$projectroot =.*#$1 \$projectroot = "'$
(dirname "$fqgitdir")'";#;
313 s#(my|our) \$gitbin =.*#$1 \$gitbin = "'$GIT_EXEC_PATH'";#;
314 s#(my|our) \$projects_list =.*#$1 \$projects_list = \$projectroot;#;
315 s#(my|our) \$git_temp =.*#$1 \$git_temp = "'$fqgitdir/gitweb
/tmp
'";#;'
318 cat > "$1.tmp" <<\EOFGITWEB
321 # Use the configured full path to perl to match the generated
322 # scripts' 'hashpling' line
323 "$PERL" -p -e "$script" "$1.tmp" > "$1"
329 cat > "$1" <<\EOFGITWEB
334 gitweb_cgi
"$GIT_DIR/gitweb/gitweb.cgi"
335 gitweb_css
"$GIT_DIR/gitweb/gitweb.css"
348 echo "Unknown httpd specified: $httpd"
354 url
=http
://127.0.0.1:$port
356 if test -n "$browser"; then
357 git web--browse
-b "$browser" $url ||
echo $url
359 git web--browse
-c "instaweb.browser" $url ||
echo $url